package zero1hd.polyjet.entity;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.graphics.g2d.ParticleEffect;
import com.badlogic.gdx.graphics.g2d.ParticleEffectPool;
import com.badlogic.gdx.utils.Array;

public class CollisionDetector {
	Array<Entity> firstGroup;
	Array<Entity> secondGroup;
	
	AssetManager assets;
	Preferences prefs;
	//Particle pools;
	ParticleEffectPool explosionEffectPool;
	Sound explosionSFX;
	public CollisionDetector(Array<Entity> firstGroup, Array<Entity> secondGroup, AssetManager assetManager, Preferences prefs) {
		this.firstGroup = firstGroup;
		this.secondGroup = secondGroup;
		assets = assetManager;
		this.prefs = prefs;
		
		explosionEffectPool = new ParticleEffectPool(assets.get("explosion-s.p", ParticleEffect.class), 1, 64);
		explosionSFX = assets.get("explosion.ogg", Sound.class);
	}
	
	public void collisionCheck() {
		if ((firstGroup.size != 0) && (secondGroup.size != 0)) {
			for (int f = 0; f < firstGroup.size; f++) {
				Entity fe = firstGroup.get(f);
				for (int s = 0; s < secondGroup.size; s++) {
					Entity se = secondGroup.get(s);
					
					if (fe.getHitZone().overlaps(se.getHitZone())) {
						Gdx.app.debug("Collision Detector", "Collision between entities: " + fe.getEntityType() + " and " + se.getEntityType());
						
						fe.collided(se);
						se.collided(fe);
						break;
					}
				}
			}
		}
	}
}
